"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Text = void 0;
/** @jsxRuntime classic */
/** @jsx withSlots */
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var framework_1 = require("@fluentui-react-native/framework");
var interactive_hooks_1 = require("@fluentui-react-native/interactive-hooks");
var theme_tokens_1 = require("@fluentui-react-native/theme-tokens");
var Text_types_1 = require("./Text.types");
var TextTokens_1 = require("./TextTokens");
var emptyProps = {};
exports.Text = (0, framework_1.compressible)(function (props, useTokens) {
    var _a;
    if (props === undefined) {
        props = emptyProps;
    }
    // split out color and variant from props
    var _b = props.align, align = _b === void 0 ? undefined : _b, block = props.block, color = props.color, componentRef = props.componentRef, font = props.font, italic = props.italic, numberOfLines = props.numberOfLines, onAccessibilityTap = props.onAccessibilityTap, onKeyUp = props.onKeyUp, onKeyDown = props.onKeyDown, keyUpEvents = props.keyUpEvents, keyDownEvents = props.keyDownEvents, onPress = props.onPress, size = props.size, strikethrough = props.strikethrough, style = props.style, _c = props.truncate, truncate = _c === void 0 ? false : _c, underline = props.underline, variant = props.variant, weight = props.weight, _d = props.wrap, wrap = _d === void 0 ? true : _d, rest = __rest(props, ["align", "block", "color", "componentRef", "font", "italic", "numberOfLines", "onAccessibilityTap", "onKeyUp", "onKeyDown", "keyUpEvents", "keyDownEvents", "onPress", "size", "strikethrough", "style", "truncate", "underline", "variant", "weight", "wrap"]);
    var theme = (0, framework_1.useFluentTheme)();
    // get the tokens from the theme
    var _e = useTokens(theme), tokens = _e[0], cache = _e[1];
    var textAlign = react_native_1.I18nManager.isRTL
        ? align === 'start'
            ? 'right'
            : align === 'end'
                ? 'left'
                : align
        : align === 'start'
            ? 'left'
            : align === 'end'
                ? 'right'
                : align;
    var textOnPress = react_1.default.useCallback(function (e) {
        if (onPress) {
            onPress(e);
        }
        e.stopPropagation();
    }, [onPress]);
    var keyProps = (0, interactive_hooks_1.useKeyProps)(textOnPress, ' ', 'Enter');
    var onAccTap = react_1.default.useCallback(function (event) {
        onAccessibilityTap ? onAccessibilityTap() : onPress(event);
    }, [onPress, onAccessibilityTap]);
    // override tokens from props
    _a = (0, framework_1.patchTokens)(tokens, cache, {
        color: color,
        variant: variant,
        fontFamily: font == 'base' ? 'primary' : font,
        fontMaximumSize: tokens.maximumFontSize,
        fontSize: theme_tokens_1.globalTokens.font['size' + size],
        fontWeight: theme_tokens_1.globalTokens.font.weight[weight],
        // leave it undefined for tokens to be set by user
        fontStyle: italic ? 'italic' : undefined,
        textAlign: textAlign,
        textDecorationLine: underline && strikethrough ? 'underline line-through' : underline ? 'underline' : strikethrough ? 'line-through' : undefined,
    }), tokens = _a[0], cache = _a[1];
    // now build the text style from tokens that can be shared between different Text instances
    var tokenStyle = cache(function () { return (__assign({ margin: 0, color: tokens.color, fontStyle: tokens.fontStyle, textAlign: tokens.textAlign, textDecorationLine: tokens.textDecorationLine }, framework_1.fontStyles.from(tokens, theme))); }, __spreadArray(['color', 'fontStyle', 'textAlign', 'textDecorationLine'], framework_1.fontStyles.keys, true))[0];
    // Safety measure: Dynamic Type is an iOS-specific thing
    var dynamicTypeVariant = react_native_1.Platform.OS === 'ios' ? tokenStyle.dynamicTypeRamp : undefined;
    var maxFontSizeScaleAdjustment = emptyProps;
    // tokenStyle.fontSize can also be a string (e.g., "14px").
    // Therefore, we only support scaling for number-based size values in order to avoid any messy calculations.
    if (dynamicTypeVariant !== undefined && typeof tokenStyle.fontSize === 'number' && tokenStyle.maximumFontSize !== undefined) {
        maxFontSizeScaleAdjustment = {
            maxFontSizeMultiplier: tokenStyle.maximumFontSize / tokenStyle.fontSize,
        };
    }
    var isWinPlatform = react_native_1.Platform.OS === ('win32' || 'windows');
    var filteredProps = {
        onKeyUp: isWinPlatform ? onKeyUp : undefined,
        keyUpEvents: isWinPlatform ? keyUpEvents : undefined,
        validKeysUp: undefined,
        onKeyDown: isWinPlatform ? onKeyDown : undefined,
        keyDownEvents: isWinPlatform ? keyDownEvents : undefined,
        validKeysDown: undefined,
        onAccessibilityTap: isWinPlatform ? onAccTap : undefined,
    };
    // return a continuation function that allows this text to be compressed
    return function (extra, children) {
        var mergedProps = __assign(__assign(__assign(__assign(__assign(__assign({}, rest), keyProps), filteredProps), extra), maxFontSizeScaleAdjustment), { onPress: onPress, numberOfLines: numberOfLines !== null && numberOfLines !== void 0 ? numberOfLines : (truncate || !wrap ? 1 : 0), style: (0, framework_1.mergeStyles)(tokenStyle, props.style, extra === null || extra === void 0 ? void 0 : extra.style) });
        // RN TextStyle doesn't recognize these properties.
        // Don't let them leak through or RN will complain about invalid props.
        delete mergedProps.style.dynamicTypeRamp;
        delete mergedProps.style.maximumFontSize;
        return ((0, framework_1.withSlots)(react_native_1.Text, __assign({ ref: componentRef, ellipsizeMode: !wrap && !truncate ? 'clip' : 'tail' }, mergedProps), children));
    };
}, TextTokens_1.useTextTokens);
exports.Text.displayName = Text_types_1.textName;
exports.default = exports.Text;
//# sourceMappingURL=Text.js.map