"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var renderer = __importStar(require("react-test-renderer"));
var Text_1 = require("../Text");
describe('Text component tests', function () {
    it('Text default', function () {
        var tree = renderer.create(React.createElement(Text_1.Text, null, "Text default")).toJSON();
        expect(tree).toMatchSnapshot();
    });
    it('Text all props', function () {
        var tree = renderer.create(React.createElement(Text_1.Text, { variant: "bodyStandard" }, "All props")).toJSON();
        expect(tree).toMatchSnapshot();
    });
    it('Text all tokens', function () {
        var BoldText = Text_1.Text.customize({
            fontFamily: 'Wingdings',
            fontWeight: '900',
            fontSize: 20,
        });
        var tree = renderer.create(React.createElement(BoldText, null, "All tokens")).toJSON();
        expect(tree).toMatchSnapshot();
    });
    it('Text variants render correctly with style', function () {
        var style = {
            marginBottom: 8,
            marginTop: 4,
        };
        var tree = renderer.create(React.createElement(Text_1.Text, { variant: "heroLargeSemibold", color: "blue", style: style }, "Header Text"));
        expect(tree).toMatchSnapshot();
    });
});
//# sourceMappingURL=Text.test.js.map