import * as React from 'react';
import * as renderer from 'react-test-renderer';
import { Text } from '../Text';
describe('Text component tests', function () {
    it('Text default', function () {
        var tree = renderer.create(React.createElement(Text, null, "Text default")).toJSON();
        expect(tree).toMatchSnapshot();
    });
    it('Text all props', function () {
        var tree = renderer.create(React.createElement(Text, { variant: "bodyStandard" }, "All props")).toJSON();
        expect(tree).toMatchSnapshot();
    });
    it('Text all tokens', function () {
        var BoldText = Text.customize({
            fontFamily: 'Wingdings',
            fontWeight: '900',
            fontSize: 20,
        });
        var tree = renderer.create(React.createElement(BoldText, null, "All tokens")).toJSON();
        expect(tree).toMatchSnapshot();
    });
    it('Text variants render correctly with style', function () {
        var style = {
            marginBottom: 8,
            marginTop: 4,
        };
        var tree = renderer.create(React.createElement(Text, { variant: "heroLargeSemibold", color: "blue", style: style }, "Header Text"));
        expect(tree).toMatchSnapshot();
    });
});
//# sourceMappingURL=Text.test.js.map